/*
 * Delete an MSDOS file
 *
 * Emmet P. Gray			US Army, HQ III Corps & Fort Hood
 * ...!uunet!uiucuxc!fthood!egray	Attn: AFZF-DE-ENV
 * fthood!egray@uxc.cso.uiuc.edu	Directorate of Engineering & Housing
 * 					Environmental Management Office
 * 					Fort Hood, TX 76544-5057
 */

/*
 *
 * Modification for X-Files program
 *
 * Marc Lebas				marc-lebas@calvanet.calvacom.fr
 *
 *  
 *
 */

#include <stdio.h>
#include <signal.h>
#include "msdos.h"
#include "patchlevel.h"

extern int fd;				/* the file descriptor for the device */
extern int dir_start;				/* starting sector for directory */
extern int dir_len;				/* length of directory (in sectors) */
extern int dir_entries;			/* number of directory entries */
extern int clus_size;				/* cluster size (in sectors) */
extern char *mcwd;				/* the Current Working Directory */
extern int fat_error;				/* FAT error detected? */

//static int got_signal();
int subdir(char drive, char *pathname);
int match(char *s, char *p);
int fat_free(unsigned int fat);
//int init(char drive, int mode);

mdel(int argc, char *argv[])
{
	int i, ismatch, entry, nogo, verbose, fargn, got_one, missed_one;
	unsigned int start;
	char *filename, *newfile, *get_name(char *name), *unix_name(unsigned char *name, unsigned char *name2), *get_path(char *name);
	char *pathname, ans[10], drive, get_drive(char *name), last_drive;
	void fat_write(), dir_write(int num, struct directory *dir), dir_flush_w(), disk_flush_w();
	struct directory *dir, *dir_read(int num);
					/* catch signals */
//	signal(SIGINT, (SIG_TYPE(*) ()) got_signal);
//	signal(SIGTERM, (SIG_TYPE(*) ()) got_signal);
//	signal(SIGQUIT, (SIG_TYPE(*) ()) got_signal);

	got_one = 0;
	missed_one = 0;

	if (argc > 1 && !strcmp(argv[1], "-v")) {
		verbose = 1;
		fargn = 2;
	}
	else {
		verbose = 0;
		fargn = 1;
	}
	if (argc < 2 || (argv[1][0] == '-' && !verbose)) {
		fprintf(stderr, "Mtools version %s, dated %s\n", VERSION, DATE);
		fprintf(stderr, "Usage: %s [-v] msdosfile [msdosfiles...]\n", argv[0]);
		exit(1);
	}
	last_drive = 'x';
//	mcwd = fix_mcwd();

	for (i = fargn; i < argc; i++) {
printf("argv[i]=%s\n", argv[i]);
		drive = get_drive(argv[i]);
		if (drive != last_drive) {
			if (last_drive != 'x') {
				fat_write();
				dir_flush_w();
				disk_flush_w();
			}

//			if (init(drive, 2)) {
//				fprintf(stderr, "%s: Cannot initialize '%c:'\n", argv[0], drive);
//				missed_one++;
//				continue;
//			}
			last_drive = drive;
		}
		filename = get_name(argv[i]);
		pathname = get_path(argv[i]);
		if (subdir(drive, pathname)) {
printf("missed_one\n");
			missed_one++;
			continue;
		}

		nogo = 0;
		ismatch = 0;
		for (entry = 0; entry < dir_entries; entry++) {
			dir = dir_read(entry);
printf("entry=%d -> %d\n", entry, dir->name[0]);
					/* if empty */
			if (dir->name[0] == 0x0)
				break;
					/* if erased */
			if (dir->name[0] == 0xe5)
				continue;
					/* if dir or volume label */
			if ((dir->attr & 0x10) || (dir->attr & 0x08))
				continue;

			newfile = unix_name(dir->name, dir->ext);
printf("newfile=%s, filename=%s\n", newfile, filename);
					/* see it if matches the pattern */
			if (match(newfile, filename)) {
//				if (verbose)
					printf("Removing %s\n", newfile);
				ismatch = 1;
//				if (dir->attr & 0x01) {
//					while (!nogo) {
//						printf("%s: \"%s\" is read only, erase anyway (y/n) ? ", argv[0], newfile);
//						gets(ans);
//						if (ans[0] == 'y' || ans[0] == 'Y')
//							break;
//						if (ans[0] == 'n' || ans[0] == 'N')
//							nogo = 1;
//					}
//					if (nogo)
//						continue;
//				}
				start = dir->start[1] * 0x100 + dir->start[0];
				if (fat_free(start))
{
			fprintf(stderr, "%s: fat error\n", argv[0]);
					break;
}
				dir->name[0] = 0xe5;
				dir_write(entry, dir);
				got_one++;
			}
		}
		if (fat_error) {
			fprintf(stderr, "%s: fat error\n", argv[0]);
			missed_one++;
			break;
		}

		if (!ismatch) {
			fprintf(stderr, "%s: File \"%s\" not found\n", argv[0], filename);
			missed_one++;
		}
	}
					/* write the FAT, flush the buffers */
printf("FAT write\n");
	fat_write();
	dir_flush_w();
	disk_flush_w();
//	close(fd);
//	if (got_one && missed_one)
//		exit(2);
//	if (missed_one)
//		exit(1);
//	exit(0);
}

/*
 * Do a graceful exit if the program is interrupted.  This will reduce
 * (but not eliminate) the risk of generating a corrupted disk on
 * a user abort.
 */

//static int
//got_signal()
//{
//	void exit(), disk_flush_w(), fat_write(), dir_flush_w();
//
//	if (fd < 0)
//		exit(1);
//	fat_write();
//	dir_flush_w();
//	disk_flush_w();
//	close(fd);
//	exit(1);
//}
